"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
exports.__esModule = true;
var carlo = require("carlo");
var commander_1 = require("commander");
var packageJson = require('../package.json');
var stdin = '';
var isStarted = false;
var command;
var commandOptions;
var program = new commander_1.Command();
program.version(packageJson.version);
program
    .command('graph')
    .option('-d, --directed', 'Make edges directed')
    .action(function (o) {
    command = 'graph';
    commandOptions = o;
});
program.parse(process.argv);
if (command === undefined || commandOptions === undefined) {
    program.outputHelp();
    process.exit();
}
var start = function () {
    if (isStarted)
        return;
    isStarted = true;
    var table = stdin
        .trim()
        .split(/[\r\n]+/)
        .map(function (line) { return line.split(/\s+/); });
    var options = { type: command };
    switch (command) {
        case 'graph': {
            options.graph = { nodes: [], edges: [], directed: !!commandOptions.directed };
            var header = table[0];
            var body = table.slice(1);
            var nodeCount = Number(header[0]);
            var nodeMap_1 = new Map();
            body.forEach(function (row) {
                var edge = [undefined, undefined, undefined];
                for (var j = 0; j < Math.min(2, row.length); j++) {
                    if (!nodeMap_1.has(row[j])) {
                        nodeMap_1.set(row[j], options.graph.nodes.length);
                        options.graph.nodes.push(row[j]);
                    }
                    edge[j] = nodeMap_1.get(row[j]);
                }
                if (edge[0] !== undefined || edge[1] !== undefined) {
                    edge[2] = row[2];
                    options.graph.edges.push(edge);
                }
            });
            while (options.graph.nodes.length < nodeCount) {
                options.graph.nodes.push(undefined);
            }
            break;
        }
    }
    (function () { return __awaiter(void 0, void 0, void 0, function () {
        var app;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, carlo.launch({ width: 512, height: 512, title: packageJson.name })];
                case 1:
                    app = _a.sent();
                    app.on('exit', function () { return process.exit(); });
                    app.serveFolder(__dirname);
                    return [4 /*yield*/, app.exposeFunction('getOptions', function () { return options; })];
                case 2:
                    _a.sent();
                    return [4 /*yield*/, app.load('index.html')];
                case 3:
                    _a.sent();
                    return [2 /*return*/];
            }
        });
    }); })()["catch"](function (reason) {
        console.error(reason);
    });
};
process.stdin.setEncoding('utf8');
process.stdin.on('data', function (chunk) {
    stdin += chunk;
});
process.stdin.on('end', function () {
    start();
});
// for Windows
process.on('SIGINT', function () {
    start();
});
